<?php if (! empty($this->request->data['Variants'])): ?>
	<div class="sortable">

		<?php $open = ' open'; ?>
		<?php if (count($this->request->data['Variants']) > 1): ?>
			<div class="flash flash--info flash--condensed">
				<h2 class='flash__title'>Drag variants to reorder.</h2>
			</div>
			<?php
				$open = false;
				$this->Html->script(
					array('EvShop.variantsManage'),
					array('inline' => false)
				);
			?>
		<?php endif; ?>

		<?php foreach ($this->request->data['Variants'] as $key => $Variant): ?>
			<?php
			$options = array();
			if (isset($Variant['Option']) && ! empty($Variant['Option'])):
				foreach ($Variant['Option'] as $option):
					$options[] = $option['id'];
				endforeach;
			endif;
			?>
			<fieldset class="collapsable-fieldset<?=$open?> variant-record" data-variant="<?=$Variant['Variant']['id']?>" data-options="<?=implode(",", $options)?>">
				<legend><?php echo (isset($Variant['Variant']['name']) ? $Variant['Variant']['name'] : null); ?></legend>
				<div>
					<?php
						foreach ($fields as $field => $attr):
							if (in_array($field, array('optionDesc', 'Variant.name')) && ! empty($open)):
								continue;
							endif;

							echo $this->Form->addField(
								'Variants.' . $key . '.' . $field,
								$attr
							);
						endforeach;
					?>
					<span class="collapsable-fieldset--inline-label">Pricing</span>
						<?php
						foreach ($currencies as $currencyId => $currencyName):
							if (Configure::read('EvShop.autoManageCurrencies') == true && isset($defaultCurrency) && $currencyId != $defaultCurrency):
								continue;
							endif;
						?>
						<fieldset class="collapsable-fieldset collapsable-fieldset--inline">
							<legend>Currency: <?php echo $currencyName; ?></legend>
							<div>
								<?php
								$priceId = null;
								if (isset($Variant['VariantPricing'][$currencyId]['od'])):
									$priceId = $Variant['VariantPricing'][$currencyId]['id'];
								endif;
								echo $this->Form->addField(
									'Variants.' . $key . '.VariantPricing.' . $currencyId . '.id',
									array(
										'type' => 'hidden',
										'value' => $priceId
									)
								);

								echo $this->Form->addField(
									'Variants.' . $key . '.VariantPricing.' . $currencyId . '.currency_id',
									array(
										'type' => 'hidden',
										'value' => $currencyId
									)
								);

								$rrp = null;
								if (isset($Variant['VariantPricing'][$currencyId]['rrp'])):
									if (substr(strval($Variant['VariantPricing'][$currencyId]['rrp']), -1) == 0) {
										$rrp = $this->Number->precision($Variant['VariantPricing'][$currencyId]['rrp'], 3);
									} else {
										$rrp = $this->Number->precision($Variant['VariantPricing'][$currencyId]['rrp'], 2);
									}
								endif;
								echo $this->Form->addField(
									'Variants.' . $key . '.VariantPricing.' . $currencyId . '.rrp',
									array(
										'type' => 'input',
										'label' => 'RRP',
										'value' => $rrp,
										'after' => '<div class="display-info">Excluding tax</div>',
										'data-type' => 'currency',
										'data-field' => 'rrp',
										'data-taxrate' => (isset($Variant['Product']['TaxLevel']['rate']) ? $Variant['Product']['TaxLevel']['rate'] : null),
										'data-currency' => $currencyId
									)
								);

								$price = null;
								if (isset($Variant['VariantPricing'][$currencyId]['price'])):
									if (substr(strval($Variant['VariantPricing'][$currencyId]['rrp']), -1) == 0) {
										$price = $this->Number->precision($Variant['VariantPricing'][$currencyId]['price'], 3);
									} else {
										$price = $this->Number->precision($Variant['VariantPricing'][$currencyId]['price'], 2);
									}
								endif;
								echo $this->Form->addField(
									'Variants.' . $key . '.VariantPricing.' . $currencyId . '.price',
									array(
										'type' => 'input',
										'value' => $price,
										'after' => '<div class="display-info">Excluding tax</div>',
										'data-type' => 'currency',
										'data-field' => 'price',
										'data-taxrate' => (isset($Variant['Product']['TaxLevel']['rate']) ? $Variant['Product']['TaxLevel']['rate'] : null),
										'data-currency' => $currencyId
									)
								);

								$sale_price = null;
								if (isset($Variant['VariantPricing'][$currencyId]['sale_price'])):
									if (substr(strval($Variant['VariantPricing'][$currencyId]['rrp']), -1) == 0) {
										$sale_price = $this->Number->precision($Variant['VariantPricing'][$currencyId]['sale_price'], 3);
									} else {
										$sale_price = $this->Number->precision($Variant['VariantPricing'][$currencyId]['sale_price'], 2);
									}
								endif;

								echo $this->Form->addField(
									'Variants.' . $key . '.VariantPricing.' . $currencyId . '.sale_price',
									array(
										'type' => 'input',
										'value' => $sale_price,
										'after' => '<div class="display-info">Excluding tax</div>',
										'data-type' => 'currency',
										'data-field' => 'sale_price',
										'data-taxrate' => (isset($Variant['Product']['TaxLevel']['rate']) ? $Variant['Product']['TaxLevel']['rate'] : null),
										'data-currency' => $currencyId
									)
								);

								$trade_price = null;
								if (isset($Variant['VariantPricing'][$currencyId]['trade_price'])):
									if (substr(strval($Variant['VariantPricing'][$currencyId]['rrp']), -1) == 0) {
										$trade_price = $this->Number->precision($Variant['VariantPricing'][$currencyId]['trade_price'], 3);
									} else {
										$trade_price = $this->Number->precision($Variant['VariantPricing'][$currencyId]['trade_price'], 2);
									}
								endif;

								echo $this->Form->addField(
									'Variants.' . $key . '.VariantPricing.' . $currencyId . '.trade_price',
									array(
										'type' => 'input',
										'value' => $trade_price,
										'after' => '<div class="display-info">Tax will not be applied to trade orders.</div>',
										'data-type' => 'currency',
										'data-field' => 'trade_price',
										'data-taxrate' => (isset($Variant['Product']['TaxLevel']['rate']) ? $Variant['Product']['TaxLevel']['rate'] : null),
										'data-currency' => $currencyId
									)
								);
								?>
							</div>
						</fieldset>

						<?php
						endforeach;

						if (CakePlugin::loaded('EvInventory')):
							echo $this->element(
								'EvInventory.stockControl',
								array('fieldPrefix' => 'Variants.' . $key)
							);
						endif;
					?>
				</div>
			</fieldset>

		<?php endforeach; ?>
	</div>

<?php endif; ?>

<?php
echo $this->Html->script(
	array(
		'EvShop.autoNumeric.min.js',
		'EvShop.variantPricing.js'
	),
	array(
		'inline' => false
	)
);
?>
