var variantOptions = [];
var selectedVariants = [];

$(document).ready(function() {

    // Bulk-pricing updater

        // Loop through all the variant records and get an array of their options

        $('fieldset.variant-record').each(function(e) {
            var optionList = $(this).attr('data-options').split(',');
            variantOptions[$(this).attr('data-variant')] = optionList;
        });

        $('input[type=checkbox].variant-option-selector').on('change', function() {
            selectedVariants = [];
            rebuildSelectedVariants();
        });

        $('.variant-modal-save').on('click', function() {
            updateSelectedVariants();
            resetVariantModal();

            $('#optionsModal').find('.modal-loading').fadeIn('fastest').delay(1000, function() {
                $(this).closest('#optionsModal').modal('hide').find('.modal-loading').fadeOut('fastest');
                // USE BS EVENT TO DETECT CLOSE AND THEN HIDE THE LOADING BIT
            });


        });

    // Virtual tax field generation

    $('input[data-type=currency]').each(function(e) {

        if ($(this).attr('data-taxrate') > 0) {

            var thisInput = $(this);
            var cloned = $(this).parent().clone();
            cloned.addClass('taxed');
            cloned.find('label').html($(this).parent().find('label').html() + ' (inc. Tax)');
            cloned.find('input').attr('data-type', 'currency-taxed');
            cloned.find('input').attr('name', 'taxed_' + $(this).attr('name'));
            cloned.find('.display-info').remove();

            $(this).parent().after(cloned);

            if ($(this).val() > 0) {
                cloned.find('input').val(calculateTax($(this)));
            }

            $(this).on('change keyup', function() {
                cloned.find('input').val(calculateTax($(this)));
            });

            cloned.find('input').on('change keyup', function() {
                thisInput.val(calculateReverseTax(cloned.find('input')));
            });
        }
    });
});


function calculateTax(input) {
    var taxRate = '1.' + parseInt(input.attr('data-taxrate'));
    var value = input.val();
    var taxedValue = value * taxRate;
    taxedValue = (Math.round(taxedValue * 100) / 100).toFixed(2);

    return taxedValue;
}

function calculateReverseTax(input) {
    var taxRate = '1.' + parseInt(input.attr('data-taxrate'));
    var value = input.val();
    var untaxedValue = (value / taxRate).toFixed(3);

    if (untaxedValue.toString()[untaxedValue.length - 1] == 0) {
    	untaxedValue = parseFloat(untaxedValue).toFixed(2);
    } else {
		untaxedValue = parseFloat(untaxedValue)
    }

    return untaxedValue;

}

function rebuildSelectedVariants() {

    var selectedOptions = [];
    selectedVariants = [];

    $('input[type=checkbox].variant-option-selector').each(function() {
        if ($(this).prop('checked')) {
            selectedOptions.push($(this).attr('data-option'));
        }
    });
    // Recalculate selected variants
    $('fieldset.variant-record').each(function(e) {
        var optionList = $(this).attr('data-options').split(',');
        var selectedItems = [];
        for(var i = 0; i<= optionList.length; i++) {
            var option = optionList[i];

            if (option != undefined && option > 0) {
                if (option > 0 && jQuery.inArray(option, selectedOptions) !== -1) {
                    console.log(option + ' is in array');
                    console.log(selectedOptions);
                    selectedItems.push(option);
                }
            }
        }

        if(selectedItems.length == selectedOptions.length && jQuery.inArray($(this).attr('data-variant'), selectedVariants) == -1) {
            selectedVariants.push($(this).attr('data-variant'));
        } else {
            selectedVariants = jQuery.grep(selectedVariants, function (value) {
                return value != $(this).attr('data-variant');
            })
        }
    });

    if(selectedOptions.length <= 0) {
        selectedVariants = [];
    }

    // update total display
    $('.totalApplicableVariants').parent().fadeOut(150).fadeIn(150).fadeOut(150).fadeIn(150);
    $('.totalApplicableVariants').html(selectedVariants.length);
}

function updateSelectedVariants() {

    // get a master list of the bulk-update values to use
    var rrpList = [];
    var priceList = [];
    var salePriceList = [];
    var tradePriceList = [];

    $('#optionsModal').find('input[data-type=currency]').each(function() {
        if ($(this).attr('data-field') == 'rrp') {
            rrpList[$(this).attr('data-currency')] = $(this).val();
        } else if ($(this).attr('data-field') == 'price') {
            priceList[$(this).attr('data-currency')] = $(this).val();
        } else if ($(this).attr('data-field') == 'sale_price') {
            salePriceList[$(this).attr('data-currency')] = $(this).val();
        } else if ($(this).attr('data-field') == 'trade_price') {
            tradePriceList[$(this).attr('data-currency')] = $(this).val();
        }
    });

    $('fieldset.variant-record').each(function(e) {

        var variantId = $(this).attr('data-variant');

        if(jQuery.inArray(variantId, selectedVariants) !== -1) {

            $(this).find('input[data-type=currency]').each(function() {
                if ($(this).attr('data-field') == 'rrp') {
                    $(this).val(rrpList[$(this).attr('data-currency')]);
                } else if ($(this).attr('data-field') == 'price') {
                    $(this).val(priceList[$(this).attr('data-currency')]);
                } else if ($(this).attr('data-field') == 'sale_price') {
                    $(this).val(salePriceList[$(this).attr('data-currency')]);
                } else if ($(this).attr('data-field') == 'trade_price') {
                    $(this).val(tradePriceList[$(this).attr('data-currency')]);
                }
            });
        }
    });
}

function resetVariantModal() {

    $('#optionsModal').find('input[type=checkbox]').prop('checked', false);
    $('#optionsModal').find('input[data-type=currency]').val(null);

}
